package com.xbongbong.api.demo.customer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xbongbong.api.demo.helper.ConfigConstant;
import com.xbongbong.api.demo.helper.XbbException;

public class CustomerApi {
	
	/**
	 * 获取客户简要列表接口
	 * @param page
	 * @param pageSize
	 * @return
	 * @throws XbbException
	 */
	public static JSONArray simpleList( Integer page, Integer pageSize) throws XbbException {
		
		
		//创建参数data
		JSONObject data = new JSONObject();
		data.put("corpid", ConfigConstant.corpid);
		data.put("page", page);
		data.put("pageSize", pageSize);
		
		//调用xbbApi方法，将data传输给对应url
		String response = null;
		response =ConfigConstant.xbbApi(ConfigConstant.CUSTOMER_SIMPLE_LIST, data ); 
		
		 
		//对返回值进行解析
		JSONObject responseJson = null;
		try {
			responseJson = JSON.parseObject(response);
		} catch(Exception e) {
			throw new XbbException(-1, "json解析出错");
		}
		
		JSONArray retArray = null;
		if(responseJson.containsKey("errorCode") && responseJson.getInteger("errorCode").equals(0)) {
			retArray = responseJson.getJSONArray("customerList");
			return retArray;
		} else {
			throw new XbbException(responseJson.getInteger("errorCode"), responseJson.getString("msg"));
		}
	}
	
	
	
	 
	
}
