package com.xbongbong.api.demo.helper;

import com.alibaba.fastjson.JSONObject;

public class ConfigConstant {
	//接口根地址
	public static final String XBB_API_ROOT = "http://dingapi.xbongbong.com"; 
	//本公司corpid 管理员账号登录销帮帮WEB版后台后，访问https://dingtalk.xbongbong.com/apiSetting/detail.html查看
	public static final String corpid = "";
	//本公司访问接口的token,该值相当于密钥，请妥善保管，不要泄露，可以下列url中重置token, 
	//管理员账号登录销帮帮WEB版后台后，访问https://dingtalk.xbongbong.com/apiSetting/detail.html查看
	public static final String token = "";
	
	
	/* ---------------------------------------------客户模块接口地址------------------------------------------------*/
	//客户列表接口
	public static final String CUSTOMER_SIMPLE_LIST = "/api/v1/customer/simpleList.html";
	
	
	/**
	 * 获取接口地址
	 * @param restApiUrl
	 * @return
	 */
	public static String getApiUrl(String restApiUrl) {
		return XBB_API_ROOT + restApiUrl;
	}
	
	/**
	 * 获取签名
	 * @param data
	 * @param token
	 * @return
	 */
	public static String getDataSign(JSONObject data, String token) {
		return getDataSign(data.toJSONString(), token);
	}
	
	/**
	 * 获取签名
	 * @param data
	 * @param token
	 * @return
	 */
	public static String getDataSign(String data, String token) {
		return  DigestUtil.Encrypt(data + token, "SHA-256");
	}
	
	/**
	 * 调用xbb api，将data进行签名 ，并拼接成http post请求，发送到指定url
	 * @param url,xbb api的接口url，不包含域名,从/开始，例如"/api/v1/customer/simpleList.html"
	 * @param token
	 * @return
	 */
	public static String xbbApi(String url,JSONObject data) throws XbbException {
		String  absoluteUrl = ConfigConstant.getApiUrl(url);
		//计算sign ，算法为 sha-256 ( data+token ),data里如果有中文要用utf-8编码
		String sign = ConfigConstant.getDataSign(data, token);
		String response = null;
		
		System.out.println("====以下输出用于调试，正式上线时请删除com.xbongbong.api.demo.helper.ConfigConstant.xbbApi()======");
		System.out.println("xbbapi url="+url);
		System.out.println("xbbapi data="+data);
		System.out.println("xbbapi sign="+sign);
		try {
			//发生post请求，data作为form值，sign在 http-header中传输
			response = HttpRequestUtils.post(absoluteUrl, data.toJSONString(), sign);
			
		} catch(Exception e) {
			throw new XbbException(-1, "http post访问出错");
		}
		return response;
		 
	}
}
